
#@fileName <YalgaarInitModule.rb>
#@brief - <Initialize all varialbes and common methods>
#
#Revision Log:
#     v1.0.2  : Aug 4, 2016   INITIAL OF PROGRAMMER - REVISION DETAIL_1        <- THIS IS THE LATEST REVISION	
#Description:
#YalgaarInitModule contents methods and variables and enum.. 
#
#@bug  Known Issues:
#	 1. ISSUE NAME - NONE
#		WORKAROUND - NONE
#@details Notes: NONE
#SLS MAKES NO REPRESENTATION, WARRANTY, OR CONDITION OF
#ANY KIND, EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE OR IN
#ANY COMMUNICATION WITH YOU, INCLUDING, BUT NOT LIMITED TO,
#ANY IMPLIED WARRANTIES OF MERCHANTABILITY, SATISFACTORY
#QUALITY, FITNESS FOR ANY PARTICULAR PURPOSE,
#NONINFRINGEMENT, AND THEIR EQUIVALENTS.
#SLS Propritery and Confidential 
#@copyright (C) 2016  SLS Corporation, All Rights Reserved.
#!/usr/bin/env ruby
require 'rubygems'
require 'openssl'
require 'base64'
require 'json'
require_relative 'mqtt'
# Namespace module for YalgaarInit default variables... 
 module YalgaarInit 
	include MQTT
	
	#YalgaarConnectionENUM for connection methods 
	YALGAARAESTYPEENUM=
	[
		YALGAR_AES_128=128,
		YALGAR_AES_192=192,
		YALGAR_AES_256=256
	]
	YalgaarConnectionENUM=
	[
		NoARGV=0x00,
		ONEARGV=0x01,
		TWOARGV=0x02,
		THREEARGV=0x03,
		FOURARGV=0x04,
		FIVEARGV=0x05,
		MAXARGV=0xFF
	]
	YalgaarErrorCodeENUM=
	[
		YALGAAR_CONNECT_SUCCESS=0,
		YALGAAR_DISCONNECT_SUCCESS=1,
		YALGAAR_101=101,
		YALGAAR_102=102,
		YALGAAR_103=103,
		YALGAAR_104=104,
		YALGAAR_105=105,
		YALGAAR_106=106,
		YALGAAR_107=107,
		YALGAAR_108=108,
		YALGAAR_109=109,
		YALGAAR_110=110,
		YALGAAR_111=111,
		YALGAAR_112=112,
		YALGAAR_113=113,
		YALGAAR_114=114,
		YALGAAR_115=115,
		YALGAAR_116=116,
		YALGAAR_117=117,
		YALGAAR_118=118,
		YALGAAR_119=119,
		YALGAAR_120=120,
		YALGAAR_121=121,
		YALGAAR_122=122,
		YALGAAR_123=123,
		YALGAAR_150=150,
		YALGAAR_NO_SERVER_CONNECTION=151,
		YALGAAR_INVALID_AES_TYPE=152,
		YALGAAR_INVALID_AES_KEY_LENGTH=153,
		YALGAAR_MAX=200
	]
	#init(message);
	#@brief - <To init as given length>		
	#@param  <Length> : <length for how long uuid generating>
	#DESCRIPTION:<To userListCallback as given length>
	def init
		#~ puts "In init"
		@@isConnected=false
		@@clientKey=nil
		@@isSecure=nil
		@@uuid=nil
		@@aesSecretKey=nil
		@@aesType=nil
		@@keepalive=30
		@@connectTimeout=60
		@@alive_time=200
		@@client=nil
		@@lErrorConnectionCallback=nil
		@@lEroorCallback=nil
		@@lSubCallback=nil
		@@lPresenceCallback=nil
		@@lHistoryCallback=nil
		@@lChannelList=nil
		@@lUserList=nil
		@@host='api.yalgaar.io'
		@@isEncrpt=nil
	end
end	

 module YalgaarApis
	include MQTT
	include YalgaarInit
	#pubACK(channel);
	#@brief - <To channelValidation>		
	#@param  <channel> : <length for how long uuid generating>
	#DESCRIPTION:<To channelValidation and callback
	def pubACK(errorCode)
		#~ puts "in puback"
		#~ puts errorCode
		if errorCode.is_a?(Array)
			#~ puts errorCode[0]
			#~ if errorCode[0] != 0
				errmesg=showErrCode(errorCode[0])
				@@lErrorConnectionCallback.call(errmesg)
				#~ puts errorCode
			#~ end
		else
			#~ puts errorCode
			#~ if errorCode != 0
				errmesg=showErrCode(errorCode)
				@@lErrorConnectionCallback.call(errmesg)
				#~ puts errorCode
			#~ end
		end	
	end
	
	#subACK(channel);
	#@brief - <To channelValidation>		
	#@param  <channel> : <length for how long uuid generating>
	#DESCRIPTION:<To channelValidation and callback
	def subACK(errorCode)
		if errorCode[0] != 0
			errmesg=showErrCode(errorCode[0])
			@@lEroorCallback.call(errmesg)
		end	
	end
	#generateUUID(length);
	#@brief - <To Generate uuid as given length>		
	#@param  <Length> : <length for how long uuid generating>
	#DESCRIPTION:<To Generate UUID as given length>
	#@bug  Known Issues:
	#1.<max 50 bytes UUID generating using this method.
	def generateUUID(len)
		if len>50
			len=10
		end	
		character_set =  ["A".."Z", "a".."z", "0".."9",'_','-','@']
		chars = character_set.map{|x| x.is_a?(Range) ? x.to_a : x }.flatten
		Array.new(len){ chars.sample }.join
	end
	
	#messageParsing(length);
	#@brief - <To messageParsing>		
	#@param  <topic,message,isEncrpt> : <length for how long uuid generating>
	#DESCRIPTION:<To messageParsing and callback
	def messageParsing(topic,message,isEncrpt)
	begin
		parse_topic=topic.split("$")[2]
		#puts "ParseTopic is :#{ parse_topic}"
		if parse_topic == "channels"
			@@lChannelList.call(message)
		elsif parse_topic == "users"
			@@lUserList.call(message)
		elsif parse_topic == "history"
			@@lHistoryCallback.call(message)		
		else
			messageAck = JSON.parse(message)
		#	puts "ParseTopic is :#{ messageAck}"
			if messageAck["uuid"] != @@uuid && messageAck["isPresence"] == true
				@@lPresenceCallback.call(message)
			elsif messageAck["uuid"] == @@uuid && messageAck["isPresence"] == true
				#@@lSubCallback.call(message)
			else
				if isEncrpt==1
					cyperText=decryption(message)
					#~ puts cyperText
					@@lSubCallback.call(cyperText)		
				else
					@@lSubCallback.call(message)
				end	
			end    
		end
		 rescue JSON::ParserError
			if isEncrpt==1
				cyperText=decryption(message)
				#~ puts cyperText
				@@lSubCallback.call(cyperText)		
			else
				@@lSubCallback.call(message)
			end		
		end
	end	
	
	#channelValidation(channel);
	#@brief - <To channelValidation>		
	#@param  <channel> : <length for how long uuid generating>
	#DESCRIPTION:<To channelValidation and callback
	def channelValidation(channel)
		validString=/^([A-Za-z0-9_@-])*$/
		temp=validString.match(channel)
		#~ #puts temp
		return temp
		#~ return 1
	end
	
	#uidValidation(channel);
	#@brief - <To uidValidation>		
	#@param  <channel> : <length for how long uuid generating>
	#DESCRIPTION:<To uidValidation and callback
	def uidValidation(uid)
		if uid.length < 50
			validString=/^([A-Za-z0-9_@-])*$/
			temp=validString.match(uid)
		#	puts temp
		else
			temp=0
		end	
		return temp
	end
	
	#encryption(channel);
	#@brief - <To encryption>		
	#@param  <channel> : <length for how long uuid generating>
	#DESCRIPTION:<To encryption and callback
	def encryption(msg)
		begin
			cipher = OpenSSL::Cipher.new(@@aesType)
			cipher.encrypt()
			cipher.key = @@aesSecretKey
			cipher.iv = @@aesSecretKey[0..15]
			crypt = cipher.update(msg) + cipher.final()
			crypt_string = (Base64.encode64(crypt))
			return crypt_string
			rescue Exception => exc
				puts "Message for the encryption log file for message #{msg} = #{exc.message}"
		end
		
	end
	
	#decryption(channel);
	#@brief - <To decryption>		
	#@param  <channel> : <length for how long uuid generating>
	#DESCRIPTION:<To decryption and callback
	def decryption(msg)
		begin
			cipher = OpenSSL::Cipher.new(@@aesType)
			cipher.decrypt()
			cipher.key = @@aesSecretKey
			cipher.iv = @@aesSecretKey[0..15]
			tempkey = Base64.decode64(msg)
			crypt = cipher.update(tempkey)
			crypt << cipher.final()
		return crypt
		rescue Exception => exc
			puts "Message for the decryption log file for message #{msg} = #{exc.message}"
		end
	end
	#showErrCode(code);
	#@brief - <To decryption>		
	#@param  <channel> : <length for how long uuid generating>
	#DESCRIPTION:<To decryption and callback
	def showErrCode(code)
		case code
			when YALGAAR_CONNECT_SUCCESS
				@@isConnected=true
				errMessage="Successfully connected with server"
			when YALGAAR_DISCONNECT_SUCCESS
				@@isConnected=false
				errMessage="Successfully Disconnected with server"
			when YALGAAR_101
				errMessage="ClientId should not be null."
			when YALGAAR_102
				errMessage="Invalid ClientId."
			when YALGAAR_103
				errMessage="Invalid ClientKey.ClientKey is not registered."
			when YALGAAR_104
				errMessage="Invalid Uuid.Only alpha numeric,hyphens,@,underscore allowed and maximum length must be 50."
			when YALGAAR_105
				errMessage="ClientKey is not active."
			when YALGAAR_106
				errMessage="SSL is not enable."
			when YALGAAR_107
				errMessage="The maximum connection limit has been reached."
			when YALGAAR_108
				errMessage="Invalid subscribe channel."
			when YALGAAR_109
				errMessage="Invalid subscribe channel.ClientKey does not match."
			when YALGAAR_110
				errMessage="Multiple subscribe channels are not allowed. Multiplexing is not enable."
			when YALGAAR_111
				errMessage="Invalid subscribe channel.Only alpha numeric,hyphens,@,underscore allowed and maximum length must be 50."
			when YALGAAR_112
				errMessage="Storage is not enable."
			when YALGAAR_113
				errMessage="Presence is not enable."
			when YALGAAR_114
				errMessage="Entered history channel has not been subscribed."
			when YALGAAR_115
				errMessage="Message can not be null."
			when YALGAAR_116
				errMessage="Invalid publish channel."
			when YALGAAR_117
				errMessage="Invalid publish channel.ClientKey does not match."
			when YALGAAR_118
				errMessage="Message count exceeds maximum limit."
			when YALGAAR_119
				errMessage="Message size exceeds maximum limit."
			when YALGAAR_120
				errMessage="Invalid publish channel.Only alpha numeric,hyphens,@,underscore allowed and maximum length must be 50."
			when YALGAAR_121
				errMessage="Invalid UnSubscribe channel."
			when YALGAAR_122
				errMessage="Invalid UnSubscribe channel.ClientKey does not match."
			when YALGAAR_123
				errMessage="Invalid UnSubscribe channel.Only alpha numeric,hyphens,@,underscore allowed and maximum length must be 50."
			when YALGAAR_150
				errMessage="Invalid IsSecure Flag."																						
			when YALGAAR_NO_SERVER_CONNECTION
				errMessage="No server connection found."
			when YALGAAR_INVALID_AES_TYPE																							
				errMessage="Invalid AES Type."
			when YALGAAR_INVALID_AES_KEY_LENGTH																							
				errMessage="Invalid AES key length."	
			else
				errMessage="Success"
		end
		errMessage		
	end
end

